# I love OpenSource :-(

## NOTE: When modifying this .spec, you do not necessarily need to care about
##       the %simple stuff. It is fine to break them, I'll fix it when I need them :)
## - Anssi

# %simple mode can be used to transform an arbitrary nvidia installer
# package to rpms, similar to %atibuild mode in fglrx.
# Macros version, rel, nsource, pkgname, distsuffix should be manually defined.
%define simple		0
%{?_without_simple: %global simple 0}
%{?_with_simple: %global simple 1}

%define name		nvidia-current

%if !%simple
# When updating, please add new ids to ldetect-lst (merge2pcitable.pl)
%define version		331.79
%define rel		1
# the highest supported videodrv abi
%define videodrv_abi	17
%endif

%define priority	9700

%define pkgname32	NVIDIA-Linux-x86-%{version}
%define pkgname64	NVIDIA-Linux-x86_64-%{version}

# Disable when the sources aren't on ftp yet, but can be downloaded from
# http://us.download.nvidia.com
%define ftp 1

# For now, backportability is kept for 2008.0 forwards.

%define drivername		nvidia-current
%define driverpkgname		x11-driver-video-%{drivername}
%define modulename		%{drivername}
# for description and documentation
%define cards			GeForce 8xxx and later cards
%define xorg_extra_modules	%{_libdir}/xorg/extra-modules
%define nvidia_driversdir	%{_libdir}/%{drivername}/xorg
%define nvidia_extensionsdir	%{_libdir}/%{drivername}/xorg
%define nvidia_modulesdir	%{_libdir}/%{drivername}/xorg
%define nvidia_libdir		%{_libdir}/%{drivername}
%define nvidia_libdir32		%{_prefix}/lib/%{drivername}
%define nvidia_bindir		%{nvidia_libdir}/bin
# The entry in Cards+ this driver should be associated with, if there is
# no entry in ldetect-lst default pcitable:
# cooker ldetect-lst should be up-to-date
%define ldetect_cards_name	%nil

# NVIDIA cards not listed in main ldetect-lst pcitable are not likely
# to be supported by nv which is from the same time period. Therefore
# mark them as not working with nv. (main pcitable entries override
# our entries)
%if %simple || %mgaversion <= 2
# nvidia/vesa
%define ldetect_cards_name	NVIDIA GeForce 400 series and later
%endif

%define biarches x86_64

%if !%simple
%ifarch %{ix86}
%define nsource %{SOURCE0}
%define pkgname %{pkgname32}
%endif
%ifarch x86_64
%define nsource %{SOURCE1}
%define pkgname %{pkgname64}
%endif
%endif

# Other packages should not require any NVIDIA libraries, and this package
# should not be pulled in when libGL.so.1 is required
%define _provides_exceptions \\.so
%define common_requires_exceptions libGL\\.so\\|libGLcore\\.so\\|libnvidia.*\\.so

%ifarch %{biarches}
# (anssi) Allow installing of 64-bit package if the runtime dependencies
# of 32-bit libraries are not satisfied. If a 32-bit package that requires
# libGL.so.1 is installed, the 32-bit mesa libs are pulled in and that will
# pull the dependencies of 32-bit nvidia libraries in as well.
%define _requires_exceptions %common_requires_exceptions\\|lib.*so\\.[^(]\\+\\(([^)]\\+)\\)\\?$
%else
%define _requires_exceptions %common_requires_exceptions
%endif

# (anssi) Workaround wrong linking as of 310.19.
# This will probably be fixed soon (at least similar issues have been in the past).
# https://devtalk.nvidia.com/default/topic/523762/libnvidia-encode-so-310-19-has-dependency-on-missing-library/
%define _exclude_files_from_autoreq libnvidia-encode.so.%version

Summary:	NVIDIA proprietary X.org driver and libraries, current driver series
Name:		%{name}
Version:	%{version}
Release:	%mkrel %{rel}
%if !%simple
%if %ftp
Source0:	ftp://download.nvidia.com/XFree86/Linux-x86/%{version}/%{pkgname32}.run
Source1:	ftp://download.nvidia.com/XFree86/Linux-x86_64/%{version}/%{pkgname64}.run
# GPLv2 source code; see also http://cgit.freedesktop.org/~aplattner/
Source2:	ftp://download.nvidia.com/XFree86/nvidia-settings/nvidia-settings-%{version}.tar.bz2
Source3:	ftp://download.nvidia.com/XFree86/nvidia-xconfig/nvidia-xconfig-%{version}.tar.bz2
Source4:	ftp://download.nvidia.com/XFree86/nvidia-modprobe/nvidia-modprobe-%{version}.tar.bz2
Source5:	ftp://download.nvidia.com/XFree86/nvidia-persistenced/nvidia-persistenced-%{version}.tar.bz2
%else
Source0:	http://us.download.nvidia.com/XFree86/Linux-x86/%{version}/%{pkgname32}.run
Source1:	http://us.download.nvidia.com/XFree86/Linux-x86_64/%{version}/%{pkgname64}.run
# GPLv2 source code; see also http://cgit.freedesktop.org/~aplattner/
Source2:	http://us.download.nvidia.com/XFree86/nvidia-settings/nvidia-settings-%{version}.tar.bz2
Source3:	http://us.download.nvidia.com/XFree86/nvidia-xconfig/nvidia-xconfig-%{version}.tar.bz2
Source4:	http://us.download.nvidia.com/XFree86/nvidia-modprobe/nvidia-modprobe-%{version}.tar.bz2
Source5:	http://us.download.nvidia.com/XFree86/nvidia-persistenced/nvidia-persistenced-%{version}.tar.bz2
%endif
# Script for building rpms of arbitrary nvidia installers (needs this .spec appended)
Source10:	nvidia-mgabuild-skel
# include xf86vmproto for X_XF86VidModeGetGammaRampSize, fixes build on cooker
Patch3:		nvidia-settings-include-xf86vmproto.patch
%endif
License:	Freeware
BuildRoot:	%{_tmppath}/%{name}-buildroot
URL:		http://www.nvidia.com/object/unix.html
Group: 		System/Kernel and hardware
ExclusiveArch:	%{ix86} x86_64
%if !%simple
BuildRequires:	ImageMagick
BuildRequires:	gtk+2-devel
BuildRequires:	libxv-devel
BuildRequires:	MesaGL-devel
BuildRequires:	libxxf86vm-devel
BuildRequires:	vdpau-devel
%endif

%description
Source package of the current NVIDIA proprietary driver. Binary
packages are named x11-driver-video-nvidia-current.

%package -n %{driverpkgname}
Summary:	NVIDIA proprietary X.org driver and libraries for %cards
Group: 		System/Kernel and hardware
Requires(post): update-alternatives >= 1.9.0
Requires(postun): update-alternatives >= 1.9.0
Requires:	x11-server-common
Suggests:	%{drivername}-doc-html = %{version}
# Proper support for versioned kmod() was added in 2008.1:
Requires:	kmod(%{modulename}) = %{version}
# At least mplayer dlopens libvdpau.so.1, so the software will not pull in
# the vdpau library package. We ensure its installation here.
Requires:	%{_lib}vdpau1
%if !%simple && %mgaversion >= 2
Requires:	xserver-abi(videodrv) < %(echo $((%{videodrv_abi}+1)))
%endif
Conflicts:	nvidia-current-cuda-opencl <= 295.59-1
# Obsoletes for naming changes:
Obsoletes:	nvidia < 1:%{version}-%{release}
Provides:	nvidia = 1:%{version}-%{release}
Obsoletes:	nvidia97xx < %{version}-%{release}
Provides:	nvidia97xx = %{version}-%{release}

%description -n %{driverpkgname}
NVIDIA proprietary X.org graphics driver, related libraries and
configuration tools for %cards,
including the associated Quadro cards.

NOTE: You should use XFdrake to configure your NVIDIA card. The
correct packages will be automatically installed and configured.

If you do not want to use XFdrake, see README.manual-setup.

This NVIDIA driver should be used with %cards,
including the associated Quadro cards.

%package -n dkms-%{drivername}
Summary:	NVIDIA kernel module for %cards
Group:		System/Kernel and hardware
Requires:	dkms
Requires(post):	dkms
Requires(preun): dkms
Obsoletes:	dkms-nvidia < 1:%{version}-%{release}
Provides:	dkms-nvidia = 1:%{version}-%{release}
Obsoletes:	dkms-nvidia97xx < %{version}-%{release}
Provides:	dkms-nvidia97xx = %{version}-%{release}

%description -n dkms-%{drivername}
NVIDIA kernel module for %cards. This
is to be used with the %{driverpkgname} package.

%package -n %{drivername}-devel
Summary:	NVIDIA OpenGL/CUDA development liraries and headers
Group:		Development/C
Requires:	%{driverpkgname} = %{version}-%{release}
Requires:	%{drivername}-cuda-opencl = %{version}-%{release}
Obsoletes:	nvidia-devel < 1:%{version}-%{release}
Provides:	nvidia-devel = 1:%{version}-%{release}
Obsoletes:	nvidia97xx-devel < %{version}-%{release}
Provides:	nvidia97xx-devel = %{version}-%{release}
Requires:	%{_lib}vdpau-devel

%description -n %{drivername}-devel
NVIDIA OpenGL/CUDA headers for %cards. This package
is not required for normal use.

%package -n %{drivername}-cuda-opencl
Summary:	CUDA and OpenCL libraries for NVIDIA proprietary driver
Group: 		System/Kernel and hardware
Provides:	%{drivername}-cuda = %{version}-%{release}
Requires:	kmod(%{modulename}) = %{version}
Conflicts:	nvidia < 1:195.36.15-4
Conflicts:	x11-driver-video-nvidia-current <= 295.59-1

%description -n %{drivername}-cuda-opencl
Cuda and OpenCL libraries for NVIDIA proprietary driver. This package is not
required for normal use, it provides libraries to use NVIDIA cards for High
Performance Computing (HPC).

# HTML doc splitted off because of size, for live cds:
%package -n %{drivername}-doc-html
Summary:	NVIDIA html documentation (%{drivername})
Group:		System/Kernel and hardware
Requires:	%{driverpkgname} = %{version}-%{release}

%description -n %{drivername}-doc-html
HTML version of the README.txt file provided in package
%{driverpkgname}.

%prep
# No patches applied when %simple is set
%if %simple
%setup -q -c -T
%else
%setup -q -c -T -a 2 -a 3 -a 4 -a 5
cd nvidia-settings-%{version}
%patch3 -p1
cd ..
%endif
sh %{nsource} --extract-only

#%if !%simple
#cd %{pkgname}
#cd ..
#%endif

rm -rf %{pkgname}/usr/src/nv/precompiled

%if %simple
# for old releases
mkdir -p %{pkgname}/kernel
%endif

# (tmb) nuke nVidia provided dkms.conf as we need our own
rm -f %{pkgname}/kernel/dkms.conf
rm -f %{pkgname}/kernel/uvm/dkms.conf.fragment

# install our own dkms.conf
cat > %{pkgname}/kernel/dkms.conf <<EOF
PACKAGE_NAME="%{drivername}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="nvidia"
DEST_MODULE_LOCATION[0]="/kernel/drivers/char/drm"
DEST_MODULE_NAME[0]="%{modulename}"
BUILT_MODULE_NAME[1]="nvidia-uvm"
BUILT_MODULE_LOCATION[1]="uvm/"
DEST_MODULE_LOCATION[1]="/kernel/drivers/char/drm"
MAKE[0]="make SYSSRC=\${kernel_source_dir} module"
MAKE[0]+="; make SYSSRC=\${kernel_source_dir} -C uvm module KBUILD_EXTMOD=\${dkms_tree}/%{drivername}/%{version}-%{release}/build/uvm"
CLEAN="make -f Makefile.kbuild clean"
CLEAN+="; make -C uvm clean"
AUTOINSTALL="yes"
EOF

%if %simple
# backward-compatibility randomness
if ! [ -e %{pkgname}/kernel/uvm ]; then
	grep -v uvm %{pkgname}/kernel/dkms.conf > %{pkgname}/kernel/dkms.conf.2
	mv -f %{pkgname}/kernel/dkms.conf.2 %{pkgname}/kernel/dkms.conf
fi
%endif

cat > README.install.urpmi <<EOF
This driver is for %cards.

Use XFdrake to configure X to use the correct NVIDIA driver. Any needed
packages will be automatically installed if not already present.
1. Run XFdrake as root.
2. Go to the Graphics Card list.
3. Select your card (it is usually already autoselected).
4. Answer any questions asked and then quit.

If you do not want to use XFdrake, see README.manual-setup.
EOF

cat > README.manual-setup <<EOF
This file describes the procedure for the manual installation of this NVIDIA
driver package. You can find the instructions for the recommended automatic
installation in the file 'README.install.urpmi' in this directory.

- Open %{_sysconfdir}/X11/xorg.conf and make the following changes:
  o Change the Driver to "nvidia" in the Device section
  o Make the line below the only 'glx' related line in the Module section,
    adding it if it is not already there:
      Load "glx"
  o Remove any 'ModulePath' lines from the Files section
- Run "update-alternatives --set gl_conf %{_sysconfdir}/%{drivername}/ld.so.conf" as root.
- Run "ldconfig -X" as root.
EOF

%if !%simple
rm nvidia-settings-%{version}/src/*/*.a

%build
# The code contains dozens on top of dozens on top of dozens of "false" positives
export CFLAGS="%optflags -Wno-error=format-security"
export CXXFLAGS="$CFLAGS"
export LDFLAGS="%{?ldflags}"
%make -C nvidia-settings-%{version}/src/libXNVCtrl
%make -C nvidia-settings-%{version} STRIP_CMD=true
%make -C nvidia-xconfig-%{version} STRIP_CMD=true
%make -C nvidia-modprobe-%{version} STRIP_CMD=true
%make -C nvidia-persistenced-%{version} STRIP_CMD=true

# %simple
%endif

%install
rm -rf %{buildroot}
cd %{pkgname}

# menu entry
install -d -m755 %{buildroot}%{_datadir}/%{drivername}
cat > %{buildroot}%{_datadir}/%{drivername}/mageia-nvidia-settings.desktop <<EOF
[Desktop Entry]
Name=NVIDIA Display Settings
Comment=Configure NVIDIA X driver
Exec=%{_bindir}/nvidia-settings
Icon=%{drivername}-settings
Terminal=false
Type=Application
Categories=GTK;Settings;HardwareSettings;
EOF

install -d -m755	%{buildroot}%{_datadir}/applications
touch			%{buildroot}%{_datadir}/applications/mageia-nvidia-settings.desktop

# icons
install -d -m755 %{buildroot}%{_iconsdir}/hicolor/{16x16,32x32,48x48}/apps
%if !%simple
convert nvidia-settings.png -resize 16x16 %{buildroot}%{_iconsdir}/hicolor/16x16/apps/%{drivername}-settings.png
convert nvidia-settings.png -resize 32x32 %{buildroot}%{_iconsdir}/hicolor/32x32/apps/%{drivername}-settings.png
convert nvidia-settings.png -resize 48x48 %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{drivername}-settings.png
%else
# no imagemagick
[ -e nvidia-settings.png ] || cp -a usr/share/pixmaps/nvidia-settings.png .
install -m644 nvidia-settings.png %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{drivername}-settings.png
%endif

error_fatal() {
	echo "Error: $@." >&2
	exit 1
}

error_unhandled() {
	echo "Warning: $@." >&2
	echo "Warning: $@." >> warns.log
%if !%simple
	# cause distro builds to fail in case of unhandled files
	exit 1
%endif
}

parseparams() {
	for value in $rest; do
		local param=$1
		[ -n "$param" ] || error_fatal "unhandled parameter $value"
		shift
		eval $param=$value

		[ -n "$value" ] || error_fatal "empty $param"

		# resolve libdir based on $arch
		if [ "$param" = "arch" ]; then
			case "$arch" in
			NATIVE)		nvidia_libdir=%{nvidia_libdir};;
			COMPAT32)	nvidia_libdir=%{nvidia_libdir32};;
			*)		error_fatal "unknown arch $arch"
			esac
		fi
	done
}

add_to_list() {
%if !%simple
	# on distro builds, only use .manifest for %doc files
	[ "${2#%doc}" = "${2}" ] && return
%endif
	local list="$1.files"
	local entry="$2"
	echo $entry >> $list
}

install_symlink() {
	local pkg="$1"
	local dir="$2"
	mkdir -p %{buildroot}$dir
	ln -s $dest %{buildroot}$dir/$file
	add_to_list $pkg $dir/$file
}

install_lib_symlink() {
	local pkg="$1"
	local dir="$2"
	case "$file" in
	libvdpau_*.so)
		# vdpau drivers => not put into -devel
		;;
	*.so)
		pkg=nvidia-devel;;
	esac
	install_symlink $pkg $dir
}

install_file_only() {
	local pkg="$1"
	local dir="$2"
	mkdir -p %{buildroot}$dir
	# replace 0444 with more usual 0644
	[ "$perms" = "0444" ] && perms="0644"
	install -m $perms $file %{buildroot}$dir
}

install_file() {
	local pkg="$1"
	local dir="$2"
	install_file_only $pkg $dir
	add_to_list $pkg $dir/$(basename $file)
}

get_module_dir() {
	local subdir="$1"
	case "$subdir" in
	extensions*)	echo %{nvidia_extensionsdir};;
	drivers/)	echo %{nvidia_driversdir};;
	/)		echo %{nvidia_modulesdir};;
	*)		error_unhandled "unhandled module subdir $subdir"
			echo %{nvidia_modulesdir};;
	esac
}

for file in nvidia.files nvidia-devel.files nvidia-cuda.files nvidia-dkms.files nvidia-html.files; do
	rm -f $file
	touch $file
done

# install files according to .manifest
cat .manifest | tail -n +9 | while read line; do
	arch=
	style=
	subdir=
	dest=
	nvidia_libdir=

	rest=${line}
	file=${rest%%%% *}
	rest=${rest#* }
	perms=${rest%%%% *}
	rest=${rest#* }
	type=${rest%%%% *}
	[ "${rest#* }" = "$rest" ] && rest= || rest=${rest#* }

	case "$type" in
	CUDA_LIB)
		parseparams arch subdir
		install_file nvidia-cuda $nvidia_libdir/$subdir
		;;
	CUDA_SYMLINK)
		parseparams arch subdir dest
		install_lib_symlink nvidia-cuda $nvidia_libdir/$subdir
		;;
	ENCODEAPI_LIB)
		parseparams arch subdir
		install_file nvidia $nvidia_libdir/$subdir
		;;
	ENCODEAPI_LIB_SYMLINK)
		parseparams arch dest
		install_lib_symlink nvidia $nvidia_libdir
		;;
	EXPLICIT_PATH)
		parseparams dest
		install_file nvidia %{_datadir}/nvidia
		;;
	NVCUVID_LIB)
		parseparams arch subdir
		install_file nvidia-cuda $nvidia_libdir/$subdir
		;;
	NVCUVID_LIB_SYMLINK)
		parseparams arch dest
		install_lib_symlink nvidia-cuda $nvidia_libdir
		;;
	NVIFR_LIB)
		parseparams arch subdir
		install_file nvidia $nvidia_libdir/$subdir
		;;
	NVIFR_LIB_SYMLINK)
		parseparams arch dest
		install_lib_symlink nvidia $nvidia_libdir
		;;
	OPENGL_LIB)
		parseparams arch
		install_file nvidia $nvidia_libdir
		;;
	OPENGL_SYMLINK)
		parseparams arch dest
		install_lib_symlink nvidia $nvidia_libdir
		;;
	TLS_LIB)
		parseparams arch style subdir
		install_file nvidia $nvidia_libdir/$subdir
		;;
	TLS_SYMLINK)
		parseparams arch style subdir dest
		install_lib_symlink nvidia $nvidia_libdir/$subdir
		;;
	UTILITY_LIB)
		# backward-compatibility
		[ -n "${rest}" ] || rest="NATIVE $rest"
		parseparams arch subdir
		install_file nvidia $nvidia_libdir/$subdir
		;;
	UTILITY_LIB_SYMLINK)
		# backward-compatibility
		[ "${rest#* }" != "$rest" ] || rest="NATIVE $rest"
		parseparams arch dest
		install_lib_symlink nvidia $nvidia_libdir
		;;
	VDPAU_LIB)
		parseparams arch subdir
		case $file in *libvdpau_nvidia.so*);; *) continue; esac
		install_file nvidia $nvidia_libdir/$subdir
		;;
	VDPAU_SYMLINK)
		parseparams arch subdir dest
		case $file in *libvdpau_nvidia.so*);; *) continue; esac
		install_lib_symlink nvidia $nvidia_libdir/$subdir
		;;
	VDPAU_WRAPPER_LIB)
		parseparams arch subdir
		case $file in *libvdpau_nvidia.so*);; *) continue; esac
		install_file nvidia $nvidia_libdir/$subdir
		;;
	VDPAU_WRAPPER_SYMLINK)
		parseparams arch subdir dest
		case $file in *libvdpau_nvidia.so*);; *) continue; esac
		install_lib_symlink nvidia $nvidia_libdir/$subdir
		;;
	XLIB_STATIC_LIB)
		install_file nvidia-devel %{nvidia_libdir}
		;;
	XLIB_SHARED_LIB)
		install_file nvidia %{nvidia_libdir}
		;;
	XLIB_SYMLINK)
		parseparams dest
		install_lib_symlink nvidia %{nvidia_libdir}
		;;
	LIBGL_LA)
		# (Anssi) we don't install .la files
		;;
	XMODULE_SHARED_LIB|GLX_MODULE_SHARED_LIB)
		parseparams subdir
		install_file nvidia $(get_module_dir $subdir)
		;;
	XMODULE_NEWSYM)
		# symlink that is created only if it doesn't already
		# exist (i.e. as part of x11-server)
		case "$file" in
		libwfb.so)
			continue
			;;
		*)
			error_unhandled "unknown XMODULE_NEWSYM type file $file, skipped"
			continue
		esac
		parseparams subdir dest
		install_symlink nvidia $(get_module_dir $subdir)
		;;
	XMODULE_SYMLINK|GLX_MODULE_SYMLINK)
		parseparams subdir dest
		install_symlink nvidia $(get_module_dir $subdir)
		;;
	VDPAU_HEADER)
		continue
		parseparams subdir
		install_file_only nvidia-devel %{_includedir}/%{drivername}/$subdir
		;;
	OPENGL_HEADER|CUDA_HEADER)
		parseparams subdir
		install_file_only nvidia-devel %{_includedir}/%{drivername}/$subdir
		;;
	DOCUMENTATION)
		parseparams subdir
		case $subdir in
		*/html)
			add_to_list nvidia-html "%%doc %{pkgname}/$file"
			continue
			;;
		*/include/*)
			continue
			;;
		esac
		case $file in
		*XF86Config*|*nvidia-settings.png)
			continue;;
		esac
		add_to_list nvidia "%%doc %{pkgname}/$file"
		;;
	MANPAGE|NVIDIA_MODPROBE_MANPAGE)
		parseparams subdir
		case "$file" in
		*nvidia-installer*)
			# not installed
			continue
			;;
		*nvidia-settings*|*nvidia-xconfig*|*nvidia-modprobe*|*nvidia-persistenced*)
%if !%simple
			# installed separately below
			continue
%endif
			;;
		*nvidia-smi*|*nvidia-cuda-mps-control*)
			# ok
			;;
		*)
			error_unhandled "skipped unknown man page $(basename $file)"
			continue
		esac
		install_file_only nvidia %{_mandir}/$subdir
		;;
	UTILITY_BINARY)
		case "$file" in
		*nvidia-settings|*nvidia-xconfig|*nvidia-persistenced)
%if !%simple
			# not installed, we install our own copy
			continue
%endif
			;;
		*nvidia-smi|*nvidia-bug-report.sh|*nvidia-debugdump)
			# ok
			;;
		*nvidia-cuda-mps-control|*nvidia-cuda-mps-server)
			# ok
			;;
		*)
			error_unhandled "unknown binary $(basename $file) will be installed to %{nvidia_bindir}/$(basename $file)"
			;;
		esac
		install_file nvidia %{nvidia_bindir}
		;;
	UTILITY_BIN_SYMLINK)
		case $file in nvidia-uninstall) continue;; esac
		parseparams dest
		install_symlink nvidia %{nvidia_bindir}
		;;
	NVIDIA_MODPROBE)
		# A suid-root tool (GPLv2) used as fallback for loading the module and
		# creating the device nodes in case the driver component is running as
		# a non-root user (e.g. a CUDA application). While the module is automatically
		# loaded by udev rules, the device nodes are not automatically created
		# like with regular drivers and therefore this tool is installed on
		# Mageia as well, at least for now.

		# We install our self-compiled version in non-simple mode
%if %simple
		install_file nvidia %{nvidia_bindir}
%endif
		;;
	INSTALLER_BINARY)
		# not installed
		;;
	KERNEL_MODULE_SRC)
		install_file nvidia-dkms %{_usrsrc}/%{drivername}-%{version}-%{release}
		;;
	CUDA_ICD)
		# in theory this should go to the cuda subpackage, but it goes into the main package
		# as this avoids one broken symlink and it is small enough to not cause space issues
		install_file nvidia %{_sysconfdir}/%{drivername}
		;;
	APPLICATION_PROFILE)
		parseparams subdir
		# application profile filenames are versioned, we can use a common
		# non-alternativesized directory
		install_file nvidia %{_datadir}/nvidia/$subdir
		;;
	DOT_DESKTOP)
		# we provide our own for now
		;;
	UVM_MODULE_SRC)
		install_file nvidia-dkms %{_usrsrc}/%{drivername}-%{version}-%{release}/uvm
		;;
	*)
		error_unhandled "file $(basename $file) of unknown type $type will be skipped"
	esac
done

[ -z "$warnings" ] || echo "Please inform Anssi Hannula <anssi@mageia.org> or http://bugs.mageia.org/ of the above warnings." >> warns.log

%if %simple
find %{buildroot}%{_libdir} %{buildroot}%{_prefix}/lib -type d | while read dir; do
	dir=${dir#%{buildroot}}
	echo "$dir" | grep -q nvidia && echo "%%dir $dir" >> nvidia.files
done
[ -d %{buildroot}%{_includedir}/%{drivername} ] && echo "%{_includedir}/%{drivername}" >> nvidia-devel.files

# for old releases in %%simple mode
if ! [ -e %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/dkms.conf ]; then
	install -m644 kernel/dkms.conf %{buildroot}%{_usrsrc}/%{drivername}-%{version}-%{release}/dkms.conf
fi
%endif

%if !%simple
# confirm SONAME; if something else than libvdpau_nvidia.so or libvdpau_nvidia.so.1, adapt .spec as needed:
[ "$(objdump -p %{buildroot}%{nvidia_libdir}/vdpau/libvdpau_nvidia.so.%{version} | grep SONAME | gawk '{ print $2 }')" = "libvdpau_nvidia.so.1" ]

rm -f %{buildroot}%{nvidia_libdir}/vdpau/libvdpau_nvidia.so.1
rm -f %{buildroot}%{nvidia_libdir32}/vdpau/libvdpau_nvidia.so.1
%endif

# vdpau alternative symlink
install -d -m755 %{buildroot}%{_libdir}/vdpau
touch %{buildroot}%{_libdir}/vdpau/libvdpau_nvidia.so.1
%ifarch %{biarches}
install -d -m755 %{buildroot}%{_prefix}/lib/vdpau
touch %{buildroot}%{_prefix}/lib/vdpau/libvdpau_nvidia.so.1
%endif

%if !%simple
# self-built binaries
install -m755 ../nvidia-settings-%{version}/src/_out/*/nvidia-settings %{buildroot}%{nvidia_bindir}
install -m755 ../nvidia-xconfig-%{version}/_out/*/nvidia-xconfig %{buildroot}%{nvidia_bindir}
install -m755 ../nvidia-persistenced-%{version}/_out/*/nvidia-persistenced %{buildroot}%{nvidia_bindir}
install -m4755 ../nvidia-modprobe-%{version}/_out/*/nvidia-modprobe %{buildroot}%{nvidia_bindir}
%endif
# binary alternatives
install -d -m755			%{buildroot}%{_bindir}
touch					%{buildroot}%{_bindir}/nvidia-debugdump
touch					%{buildroot}%{_bindir}/nvidia-settings
touch					%{buildroot}%{_bindir}/nvidia-smi
touch					%{buildroot}%{_bindir}/nvidia-xconfig
touch					%{buildroot}%{_bindir}/nvidia-bug-report.sh
touch					%{buildroot}%{_bindir}/nvidia-modprobe
touch					%{buildroot}%{_bindir}/nvidia-persistenced
touch					%{buildroot}%{_bindir}/nvidia-cuda-mps-control
touch					%{buildroot}%{_bindir}/nvidia-cuda-mps-server
# rpmlint:
chmod 0755				%{buildroot}%{_bindir}/*

%if !%simple
# install man pages
install -m644 ../nvidia-settings-%{version}/doc/_out/*/nvidia-settings.1 %{buildroot}%{_mandir}/man1
install -m644 ../nvidia-xconfig-%{version}/_out/*/nvidia-xconfig.1 %{buildroot}%{_mandir}/man1
install -m644 ../nvidia-modprobe-%{version}/_out/*/nvidia-modprobe.1 %{buildroot}%{_mandir}/man1
install -m644 ../nvidia-persistenced-%{version}/_out/*/nvidia-persistenced.1 %{buildroot}%{_mandir}/man1
%endif
# bug #41638 - whatis entries of nvidia man pages appear wrong
gunzip %{buildroot}%{_mandir}/man1/*.gz
sed -r -i '/^nvidia\\-[a-z]+ \\- NVIDIA/s,^nvidia\\-,nvidia-,' %{buildroot}%{_mandir}/man1/*.1
cd %{buildroot}%{_mandir}/man1
rename nvidia alt-%{drivername} *
cd -
touch %{buildroot}%{_mandir}/man1/nvidia-xconfig.1%{_extension}
touch %{buildroot}%{_mandir}/man1/nvidia-settings.1%{_extension}
touch %{buildroot}%{_mandir}/man1/nvidia-modprobe.1%{_extension}
touch %{buildroot}%{_mandir}/man1/nvidia-persistenced.1%{_extension}
touch %{buildroot}%{_mandir}/man1/nvidia-smi.1%{_extension}
touch %{buildroot}%{_mandir}/man1/nvidia-cuda-mps-control.1%{_extension}

# cuda nvidia.icd
install -d -m755		%{buildroot}%{_sysconfdir}/OpenCL/vendors
touch				%{buildroot}%{_sysconfdir}/OpenCL/vendors/nvidia.icd

# ld.so.conf
install -d -m755		%{buildroot}%{_sysconfdir}/%{drivername}
echo "%{nvidia_libdir}" >	%{buildroot}%{_sysconfdir}/%{drivername}/ld.so.conf
%ifarch %{biarches}
echo "%{nvidia_libdir32}" >>	%{buildroot}%{_sysconfdir}/%{drivername}/ld.so.conf
%endif
install -d -m755		%{buildroot}%{_sysconfdir}/ld.so.conf.d
touch				%{buildroot}%{_sysconfdir}/ld.so.conf.d/GL.conf

# modprobe.conf
install -d -m755			%{buildroot}%{_sysconfdir}/modprobe.d
touch					%{buildroot}%{_sysconfdir}/modprobe.d/display-driver.conf
echo "install nvidia /sbin/modprobe %{modulename} \$CMDLINE_OPTS" > %{buildroot}%{_sysconfdir}/%{drivername}/modprobe.conf

# xinit script
install -d -m755 %{buildroot}%{_sysconfdir}/%{drivername}
cat > %{buildroot}%{_sysconfdir}/%{drivername}/nvidia-settings.xinit <<EOF
# to be sourced
#
# Do not modify this file; the changes will be overwritten.
# If you want to disable automatic configuration loading, create
# /etc/sysconfig/nvidia-settings with this line: LOAD_NVIDIA_SETTINGS="no"
#
LOAD_NVIDIA_SETTINGS="yes"
[ -f %{_sysconfdir}/sysconfig/nvidia-settings ] && . %{_sysconfdir}/sysconfig/nvidia-settings
[ "\$LOAD_NVIDIA_SETTINGS" = "yes" ] && %{_bindir}/nvidia-settings --load-config-only
EOF
chmod 0755 %{buildroot}%{_sysconfdir}/%{drivername}/nvidia-settings.xinit
install -d -m755 %{buildroot}%{_sysconfdir}/X11/xinit.d
touch %{buildroot}%{_sysconfdir}/X11/xinit.d/nvidia-settings.xinit

# install ldetect-lst pcitable files for backports
# local version of merge2pcitable.pl:read_nvidia_readme:
section="nothingyet"
set +x
[ -e README.txt ] || cp -a usr/share/doc/README.txt .
cat README.txt | while read line; do
	if [ "$section" = "nothingyet" ] || [ "$section" = "midspace" ]; then
		if echo "$line" | grep -Pq "^\s*NVIDIA GPU product\s+Device PCI ID"; then
			section="data"
		elif [ "$section" = "midspace" ] && echo "$line" | grep -Pq "legacy"; then
			break
		fi
		continue
	fi

	if [ "$section" = "data" ] && echo "$line" | grep -Pq "^\s*$"; then
		section="midspace"
		continue
	fi

	echo "$line" | grep -Pq "^\s*-+[\s-]+$" && continue
	id=$(echo "$line" | sed -nre 's,^\s*.+?\s\s+0x(....).*$,\1,p' | tr '[:upper:]' '[:lower:]')
	id2=$(echo "$line" | sed -nre 's,^\s*.+?\s\s+0x(....)\s0x(....).*$,\2,p' | tr '[:upper:]' '[:lower:]')
	subsysid=
	# not useful as of 2013-05 -Anssi
	#[ -n "$id2" ] && subsysid="	0x10de	0x$id2"
	echo "0x10de	0x$id$subsysid	\"Card:%{ldetect_cards_name}\""
done | sort -u > pcitable.nvidia.lst
set -x
[ $(wc -l pcitable.nvidia.lst | cut -f1 -d" ") -gt 200 ]
%if "%{ldetect_cards_name}" != ""
install -d -m755 %{buildroot}%{_datadir}/ldetect-lst/pcitable.d
gzip -c pcitable.nvidia.lst > %{buildroot}%{_datadir}/ldetect-lst/pcitable.d/40%{drivername}.lst.gz
%endif

export EXCLUDE_FROM_STRIP="$(find %{buildroot} -type f \! -name nvidia-settings \! -name nvidia-xconfig \! -name nvidia-modprobe \! -name nvidia-persistenced)"

%post -n %{driverpkgname}
# XFdrake used to generate an nvidia.conf file
[ -L %{_sysconfdir}/modprobe.d/nvidia.conf ] || rm -f %{_sysconfdir}/modprobe.d/nvidia.conf

current_glconf="$(readlink -e %{_sysconfdir}/ld.so.conf.d/GL.conf)"

# owned by libvdpau1, created in case libvdpau1 is installed only just after
# this package
mkdir -p %{_libdir}/vdpau

%{_sbindir}/update-alternatives \
	--install %{_sysconfdir}/ld.so.conf.d/GL.conf gl_conf %{_sysconfdir}/%{drivername}/ld.so.conf %{priority} \
	--slave %{_mandir}/man1/nvidia-settings.1%{_extension} man_nvidiasettings%{_extension} %{_mandir}/man1/alt-%{drivername}-settings.1%{_extension} \
	--slave %{_mandir}/man1/nvidia-xconfig.1%{_extension} man_nvidiaxconfig%{_extension} %{_mandir}/man1/alt-%{drivername}-xconfig.1%{_extension} \
	--slave %{_mandir}/man1/nvidia-smi.1%{_extension} nvidia-smi.1%{_extension} %{_mandir}/man1/alt-%{drivername}-smi.1%{_extension} \
	--slave %{_mandir}/man1/nvidia-cuda-mps-control.1%{_extension} nvidia-cuda-mps-control.1%{_extension} %{_mandir}/man1/alt-%{drivername}-cuda-mps-control.1%{_extension} \
	--slave %{_datadir}/applications/mageia-nvidia-settings.desktop nvidia_desktop %{_datadir}/%{drivername}/mageia-nvidia-settings.desktop \
	--slave %{_bindir}/nvidia-settings nvidia_settings %{nvidia_bindir}/nvidia-settings \
	--slave %{_bindir}/nvidia-smi nvidia_smi %{nvidia_bindir}/nvidia-smi \
	--slave %{_bindir}/nvidia-xconfig nvidia_xconfig %{nvidia_bindir}/nvidia-xconfig \
	--slave %{_bindir}/nvidia-debugdump nvidia-debugdump %{nvidia_bindir}/nvidia-debugdump \
	--slave %{_bindir}/nvidia-bug-report.sh nvidia_bug_report %{nvidia_bindir}/nvidia-bug-report.sh \
	--slave %{_bindir}/nvidia-cuda-mps-control nvidia-cuda-mps-control %{nvidia_bindir}/nvidia-cuda-mps-control \
	--slave %{_bindir}/nvidia-cuda-mps-server nvidia-cuda-mps-server %{nvidia_bindir}/nvidia-cuda-mps-server \
	--slave %{_bindir}/nvidia-modprobe nvidia-modprobe %{nvidia_bindir}/nvidia-modprobe \
	--slave %{_bindir}/nvidia-persistenced nvidia-persistenced %{nvidia_bindir}/nvidia-persistenced \
	--slave %{_sysconfdir}/X11/xinit.d/nvidia-settings.xinit nvidia-settings.xinit %{_sysconfdir}/%{drivername}/nvidia-settings.xinit \
	--slave %{_libdir}/vdpau/libvdpau_nvidia.so.1 %{_lib}vdpau_nvidia.so.1 %{nvidia_libdir}/vdpau/libvdpau_nvidia.so.%{version} \
	--slave %{_sysconfdir}/modprobe.d/display-driver.conf display-driver.conf %{_sysconfdir}/%{drivername}/modprobe.conf \
	--slave %{_sysconfdir}/OpenCL/vendors/nvidia.icd nvidia.icd %{_sysconfdir}/%{drivername}/nvidia.icd \
%ifarch %{biarches}
	--slave %{_prefix}/lib/vdpau/libvdpau_nvidia.so.1 libvdpau_nvidia.so.1 %{nvidia_libdir32}/vdpau/libvdpau_nvidia.so.%{version} \
%endif
	--slave %{xorg_extra_modules} xorg_extra_modules %{nvidia_extensionsdir} \

if [ "${current_glconf}" = "%{_sysconfdir}/nvidia97xx/ld.so.conf" ]; then
	# Adapt for the renaming of the driver. X.org config still has the old ModulePaths
	# but they do not matter as we are using alternatives for libglx.so now.
	%{_sbindir}/update-alternatives --set gl_conf %{_sysconfdir}/%{drivername}/ld.so.conf
fi
# explicit /sbin/ldconfig due to alternatives
/sbin/ldconfig -X

%if "%{ldetect_cards_name}" != ""
[ -x %{_sbindir}/update-ldetect-lst ] && %{_sbindir}/update-ldetect-lst || :
%endif

%postun -n %{driverpkgname}
if [ ! -f %{_sysconfdir}/%{drivername}/ld.so.conf ]; then
  %{_sbindir}/update-alternatives --remove gl_conf %{_sysconfdir}/%{drivername}/ld.so.conf
fi
# explicit /sbin/ldconfig due to alternatives
/sbin/ldconfig -X

%if "%{ldetect_cards_name}" != ""
[ -x %{_sbindir}/update-ldetect-lst ] && %{_sbindir}/update-ldetect-lst || :
%endif

%post -n %{drivername}-cuda-opencl
# explicit /sbin/ldconfig due to a non-standard library directory
/sbin/ldconfig -X

%post -n dkms-%{drivername}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{drivername} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{drivername} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{drivername} -v %{version}-%{release} --force

# rmmod any old driver if present and not in use (e.g. by X)
rmmod nvidia > /dev/null 2>&1 || true

%preun -n dkms-%{drivername}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{drivername} -v %{version}-%{release} --all

# rmmod any old driver if present and not in use (e.g. by X)
rmmod nvidia > /dev/null 2>&1 || true

%clean
rm -rf %{buildroot}

%files -n %{driverpkgname} -f %{pkgname}/nvidia.files
%defattr(-,root,root)
# other documentation files are listed in nvidia.files
%doc README.install.urpmi README.manual-setup

%if "%{ldetect_cards_name}" != ""
%{_datadir}/ldetect-lst/pcitable.d/40%{drivername}.lst.gz
%endif

# ld.so.conf, modprobe.conf, xinit
%ghost %{_sysconfdir}/ld.so.conf.d/GL.conf
%ghost %{_sysconfdir}/X11/xinit.d/nvidia-settings.xinit
%ghost %{_sysconfdir}/modprobe.d/display-driver.conf
%dir %{_sysconfdir}/%{drivername}
%{_sysconfdir}/%{drivername}/modprobe.conf
%{_sysconfdir}/%{drivername}/ld.so.conf
%{_sysconfdir}/%{drivername}/nvidia-settings.xinit
%if !%simple
%{_sysconfdir}/%{drivername}/nvidia.icd
%dir %{_datadir}/nvidia
%{_datadir}/nvidia/nvidia-application-profiles-%{version}-rc
%{_datadir}/nvidia/monitoring.conf
%{_datadir}/nvidia/pci.ids
%endif

%dir %{_sysconfdir}/OpenCL
%dir %{_sysconfdir}/OpenCL/vendors
%ghost %{_sysconfdir}/OpenCL/vendors/nvidia.icd

%ghost %{_bindir}/nvidia-debugdump
%ghost %{_bindir}/nvidia-settings
%ghost %{_bindir}/nvidia-smi
%ghost %{_bindir}/nvidia-xconfig
%ghost %{_bindir}/nvidia-modprobe
%ghost %{_bindir}/nvidia-persistenced
%ghost %{_bindir}/nvidia-bug-report.sh
%ghost %{_bindir}/nvidia-cuda-mps-control
%ghost %{_bindir}/nvidia-cuda-mps-server
%if !%simple
%dir %{nvidia_bindir}
%{nvidia_bindir}/nvidia-debugdump
%{nvidia_bindir}/nvidia-settings
%{nvidia_bindir}/nvidia-smi
%{nvidia_bindir}/nvidia-xconfig
%{nvidia_bindir}/nvidia-modprobe
%{nvidia_bindir}/nvidia-persistenced
%{nvidia_bindir}/nvidia-bug-report.sh
%{nvidia_bindir}/nvidia-cuda-mps-control
%{nvidia_bindir}/nvidia-cuda-mps-server
%endif

%ghost %{_mandir}/man1/nvidia-xconfig.1%{_extension}
%ghost %{_mandir}/man1/nvidia-settings.1%{_extension}
%ghost %{_mandir}/man1/nvidia-modprobe.1%{_extension}
%ghost %{_mandir}/man1/nvidia-persistenced.1%{_extension}
%ghost %{_mandir}/man1/nvidia-smi.1%{_extension}
%ghost %{_mandir}/man1/nvidia-cuda-mps-control.1%{_extension}
%if !%simple
%{_mandir}/man1/alt-%{drivername}-xconfig.1*
%{_mandir}/man1/alt-%{drivername}-settings.1*
%{_mandir}/man1/alt-%{drivername}-modprobe.1*
%{_mandir}/man1/alt-%{drivername}-persistenced.1*
%{_mandir}/man1/alt-%{drivername}-smi.1*
%{_mandir}/man1/alt-%{drivername}-cuda-mps-control.1*
%else
%{_mandir}/man1/alt-%{drivername}-*
%endif

%ghost %{_datadir}/applications/mageia-nvidia-settings.desktop
%dir %{_datadir}/%{drivername}
%{_datadir}/%{drivername}/mageia-nvidia-settings.desktop

%if !%simple
%{_iconsdir}/hicolor/16x16/apps/%{drivername}-settings.png
%{_iconsdir}/hicolor/32x32/apps/%{drivername}-settings.png
%endif
%{_iconsdir}/hicolor/48x48/apps/%{drivername}-settings.png

%if !%simple
%dir %{nvidia_libdir}
%dir %{nvidia_libdir}/tls
%dir %{nvidia_libdir}/vdpau
%{nvidia_libdir}/libGL.so.%{version}
%{nvidia_libdir}/libnvidia-glcore.so.%{version}
%{nvidia_libdir}/libnvidia-cfg.so.%{version}
%{nvidia_libdir}/libnvidia-tls.so.%{version}
%{nvidia_libdir}/vdpau/libvdpau_nvidia.so.%{version}
%{nvidia_libdir}/libGL.so.1
%{nvidia_libdir}/libnvidia-cfg.so.1
%{nvidia_libdir}/libnvidia-fbc.so.1
%{nvidia_libdir}/libnvidia-fbc.so.%{version}
%{nvidia_libdir}/libnvidia-ifr.so.1
%{nvidia_libdir}/libnvidia-ifr.so.%{version}
%{nvidia_libdir}/libnvidia-ml.so.1
%{nvidia_libdir}/libnvidia-ml.so.%{version}
%{nvidia_libdir}/libvdpau_nvidia.so
%{nvidia_libdir}/tls/libnvidia-tls.so.%{version}
# .manifest places theese on same place in 32 and 64 bit build
%{nvidia_libdir32}/libEGL.so.1
%{nvidia_libdir32}/libEGL.so.%{version}
%{nvidia_libdir32}/libGLESv1_CM.so.1
%{nvidia_libdir32}/libGLESv1_CM.so.%{version}
%{nvidia_libdir32}/libGLESv2.so.2
%{nvidia_libdir32}/libGLESv2.so.%{version}
%{nvidia_libdir32}/libnvidia-eglcore.so.%{version}
%{nvidia_libdir32}/libnvidia-glsi.so.%{version}
%ifarch %{biarches}
%dir %{nvidia_libdir32}
%dir %{nvidia_libdir32}/tls
%dir %{nvidia_libdir32}/vdpau
%{nvidia_libdir32}/libGL.so.%{version}
%{nvidia_libdir32}/libnvidia-fbc.so.1
%{nvidia_libdir32}/libnvidia-fbc.so.%{version}
%{nvidia_libdir32}/libnvidia-glcore.so.%{version}
%{nvidia_libdir32}/libnvidia-ifr.so.1
%{nvidia_libdir32}/libnvidia-ifr.so.%{version}
%{nvidia_libdir32}/libnvidia-ml.so.1
%{nvidia_libdir32}/libnvidia-ml.so.%{version}
%{nvidia_libdir32}/libnvidia-tls.so.%{version}
%{nvidia_libdir32}/libvdpau_nvidia.so
%{nvidia_libdir32}/vdpau/libvdpau_nvidia.so.%{version}
%{nvidia_libdir32}/libGL.so.1
%{nvidia_libdir32}/tls/libnvidia-tls.so.%{version}
%endif
# %simple
%endif

%ghost %{_libdir}/vdpau/libvdpau_nvidia.so.1
%ifarch %{biarches}
# avoid unowned directory
%dir %{_prefix}/lib/vdpau
%ghost %{_prefix}/lib/vdpau/libvdpau_nvidia.so.1
%endif

%if !%simple
%dir %{nvidia_modulesdir}
%{nvidia_modulesdir}/libnvidia-wfb.so.1
%endif

%if !%simple
%{nvidia_modulesdir}/libnvidia-wfb.so.%{version}
%endif

%if !%simple
%{nvidia_extensionsdir}/libglx.so.%{version}
%{nvidia_extensionsdir}/libglx.so
%endif

%if !%simple
%{nvidia_driversdir}/nvidia_drv.so
%endif

%files -n %{drivername}-devel -f %pkgname/nvidia-devel.files
%defattr(-,root,root)
%if !%simple
%{_includedir}/%{drivername}
%{nvidia_libdir}/libGL.so
%{nvidia_libdir}/libcuda.so
%{nvidia_libdir}/libnvcuvid.so
%{nvidia_libdir}/libnvidia-cfg.so
%{nvidia_libdir}/libnvidia-fbc.so
%{nvidia_libdir}/libnvidia-ifr.so
%{nvidia_libdir}/libOpenCL.so
%{nvidia_libdir}/libnvidia-ml.so
%{nvidia_libdir}/libnvidia-encode.so
# .manifest places theese on same place in 32 and 64 bit build
%{nvidia_libdir32}/libEGL.so
%{nvidia_libdir32}/libGLESv1_CM.so
%{nvidia_libdir32}/libGLESv2.so
%ifarch %{biarches}
%{nvidia_libdir32}/libnvidia-fbc.so
%{nvidia_libdir32}/libnvidia-ml.so
%{nvidia_libdir32}/libGL.so
%{nvidia_libdir32}/libcuda.so
%{nvidia_libdir32}/libnvcuvid.so
%{nvidia_libdir32}/libnvidia-ifr.so
%{nvidia_libdir32}/libOpenCL.so
%{nvidia_libdir32}/libnvidia-encode.so
%endif
%endif

%files -n dkms-%{drivername}
%defattr(-,root,root)
%doc %{pkgname}/LICENSE
%{_usrsrc}/%{drivername}-%{version}-%{release}

%files -n %{drivername}-doc-html -f %pkgname/nvidia-html.files
%defattr(-,root,root)

%files -n %{drivername}-cuda-opencl -f %pkgname/nvidia-cuda.files
%defattr(-,root,root)
# Do not preferably add any alternativeszificated binaries here,
# they cause broken symlinks.
%if !%simple
%{nvidia_libdir}/libOpenCL.so.1.0.0
%{nvidia_libdir}/libOpenCL.so.1.0
%{nvidia_libdir}/libOpenCL.so.1
%{nvidia_libdir}/libnvcuvid.so.%{version}
%{nvidia_libdir}/libnvcuvid.so.1
%{nvidia_libdir}/libnvidia-compiler.so.%{version}
%{nvidia_libdir}/libnvidia-encode.so.1
%{nvidia_libdir}/libnvidia-encode.so.%{version}
%{nvidia_libdir}/libnvidia-opencl.so.1
%{nvidia_libdir}/libnvidia-opencl.so.%{version}
%{nvidia_libdir}/libcuda.so.%{version}
%{nvidia_libdir}/libcuda.so.1
%ifarch %{biarches}
%{nvidia_libdir32}/libOpenCL.so.1.0.0
%{nvidia_libdir32}/libOpenCL.so.1.0
%{nvidia_libdir32}/libOpenCL.so.1
%{nvidia_libdir32}/libnvcuvid.so.%{version}
%{nvidia_libdir32}/libnvcuvid.so.1
%{nvidia_libdir32}/libnvidia-compiler.so.%{version}
%{nvidia_libdir32}/libnvidia-encode.so.1
%{nvidia_libdir32}/libnvidia-encode.so.%{version}
%{nvidia_libdir32}/libnvidia-opencl.so.1
%{nvidia_libdir32}/libnvidia-opencl.so.%{version}
%{nvidia_libdir32}/libcuda.so.%{version}
%{nvidia_libdir32}/libcuda.so.1
%endif
%endif


%changelog
* Thu May 29 2014 tmb <tmb> 331.79-1.mga4
+ Revision: 627773
- sync with Cauldron 331.79
- update to 331.49 Long Lived branch
- drop P4 (uvm buildfix, not needed anymore)
- handle EXPLICIT_PATH target in .manifest
- drop duplicated files in filelist
- update fillists

* Sun Dec 08 2013 tmb <tmb> 331.20-10.mga4.nonfree
+ Revision: 555916
- fix install of uvm module too

* Sun Dec 08 2013 tmb <tmb> 331.20-9.mga4.nonfree
+ Revision: 555885
- restore old install path as its hardcoded in service_harddrake, making it break installs (#11693)

* Fri Dec 06 2013 tmb <tmb> 331.20-8.mga4.nonfree
+ Revision: 555638
- rebuild for new mesa

* Sat Nov 23 2013 tmb <tmb> 331.20-7.mga4.nonfree
+ Revision: 552644
- push to /release

* Sat Nov 23 2013 tmb <tmb> 331.20-6.mga4.nonfree
+ Revision: 552614
- properly escape the dkms_tree variable

* Sat Nov 23 2013 tmb <tmb> 331.20-5.mga4.nonfree
+ Revision: 552609
- use dkms_tree variable in KBUILD_EXTMOD

* Sat Nov 23 2013 tmb <tmb> 331.20-4.mga4.nonfree
+ Revision: 552597
- make KBUILD_EXTMOD path relative so it works on buildsystem

* Sat Nov 23 2013 tmb <tmb> 331.20-3.mga4.nonfree
+ Revision: 552587
- fix uvm build when CONFIG_UIDGID_STRICT_TYPE_CHECKS is set
- add nvidia-uvm module to dkms build

* Sun Nov 17 2013 tmb <tmb> 331.20-2.mga4.nonfree
+ Revision: 551610
- push to /release

* Wed Nov 13 2013 tmb <tmb> 331.20-1.mga4.nonfree
+ Revision: 551069
- fix filelist
- update to 331.20 (new longterm branch)
- drop merged / obsolete P1, P4, P6, P7
- dont build uvm module for now (broken build)
- update filelists

* Sat Nov 02 2013 tmb <tmb> 319.60-4.mga4.nonfree
+ Revision: 549116
- use upstream fix for num_physpages change in kernel 3.11

* Thu Oct 31 2013 tmb <tmb> 319.60-3.mga4.nonfree
+ Revision: 548452
- Mageia 4 rebuild

* Mon Oct 14 2013 tmb <tmb> 319.60-2.mga4.nonfree
+ Revision: 496721
- fix build with kernel-3.12

* Thu Oct 03 2013 tmb <tmb> 319.60-1.mga4.nonfree
+ Revision: 490939
- update to 319.60

* Sat Aug 24 2013 anssi <anssi> 319.49-2.mga4.nonfree
+ Revision: 470904
- fix requires filtering for NVIFR library

* Wed Aug 21 2013 tmb <tmb> 319.49-1.mga4.nonfree
+ Revision: 469115
- fix rel

* Wed Aug 21 2013 tmb <tmb> 319.49-0.1.mga4.nonfree
+ Revision: 469114
- handle new NVIFR_LIB (OpenGL-based Inband Frame Readback library)
- update to 319.49 (official kernel-3.10 support)

* Sun Aug 11 2013 tmb <tmb> 319.32-5.mga4.nonfree
+ Revision: 465462
- rebuild with new gcc

* Thu Aug 01 2013 tmb <tmb> 319.32-4.mga4.nonfree
+ Revision: 462263
- force gcc 4.8.2 build

* Thu Aug 01 2013 tmb <tmb> 319.32-3.mga4.nonfree
+ Revision: 462230
- fix build with 3.11 series kernels (P6)

* Mon Jul 15 2013 tmb <tmb> 319.32-2.mga4.nonfree
+ Revision: 454790
- fix build with kernel 3.10 (P5, gentoo)

* Fri Jun 28 2013 tmb <tmb> 319.32-1.mga4.nonfree
+ Revision: 447858
- update to 319.32

* Sun Jun 02 2013 tmb <tmb> 319.17-4.mga4.nonfree
+ Revision: 434768
- push to nonfree/release

  + tv <tv>
    - submit to nonfree/release

* Fri May 24 2013 tv <tv> 319.17-2.mga4.nonfree
+ Revision: 426105
- rebuild with xserver-1.14

* Fri May 03 2013 anssi <anssi> 319.17-1.mga3.nonfree
+ Revision: 412170
- new long-lived maintenance version 319.17
- update files
- add missing alternatives
- fix pcitable.d generation (when backporting)
- move all alternativeszificated binaries to main driver package
  to avoid broken symlinks

* Sun Apr 07 2013 tmb <tmb> 310.44-1.mga3.nonfree
+ Revision: 408698
- 310.44 (CVE-2013-0131)

* Fri Mar 15 2013 tmb <tmb> 310.40-1.mga3.nonfree
+ Revision: 403308
- update to 310.40 (bugfixes, more hw support)
- cd

* Sun Jan 27 2013 tmb <tmb> 310.32-1.mga3.nonfree
+ Revision: 392601
- drop P5 (kernel 3.8 buildfix, merged)
- update to 310.32

* Thu Jan 10 2013 tmb <tmb> 310.19-2.mga3.nonfree
+ Revision: 344802
- include uapi headers to fix build with kernel-3.8 (P5)

* Wed Nov 21 2012 anssi <anssi> 310.19-1.mga3.nonfree
+ Revision: 320407
- update file lists (XvMC dropped as all cards it supported have been
  dropped)
- handle optional subdir for NVCUVID_LIB and ENCODEAPI_LIB
- update target card string
  o NOTE: this driver now only supports GeForce 8xxx based cards and above
- workaround linking issue of libnvidia-encode.so

  + tmb <tmb>
    - add ENCODEAPI_LIB* symbols, update filelists
    - update to 310.19

* Thu Oct 25 2012 tmb <tmb> 304.60-1.mga3.nonfree
+ Revision: 309922
- update to 304.60

* Sun Sep 30 2012 tmb <tmb> 304.51-1.mga3.nonfree
+ Revision: 300723
- update to 304.51

* Thu Sep 13 2012 tv <tv> 304.43-2.mga3.nonfree
+ Revision: 293586
- rebuild for new x11-server

* Mon Sep 10 2012 tmb <tmb> 304.43-1.mga3.nonfree
+ Revision: 292054
- update to 304.43

* Thu Sep 06 2012 tv <tv> 304.37-4.mga3.nonfree
+ Revision: 288986
- rebuild for new xserver

* Sun Aug 19 2012 tmb <tmb> 304.37-3.mga3.nonfree
+ Revision: 282366
- replace nVidia provided dkms.conf with our own customized one

* Sun Aug 19 2012 tmb <tmb> 304.37-2.mga3.nonfree
+ Revision: 282319
- add provides kmod(nvidia-current) as upstream now has provides kmod(nvidis) (mga #7113)

* Sun Aug 19 2012 tmb <tmb> 304.37-1.mga3.nonfree
+ Revision: 282100
- update filelists
- update to 304.37 (long lived branch)
- drop merged patches (P0, P5)

* Sat Aug 11 2012 tmb <tmb> 295.71-1.mga3.nonfree
+ Revision: 280501
- update to 295.71 (CVE-2012-4225)

* Fri Jul 27 2012 tmb <tmb> 295.59-2.mga3.nonfree
+ Revision: 274692
- move libnvidia-ml.so.1 from nvidia-current-cuda-opencl to
  x11-driver-video-nvidia-current as it is needed by
  /usr/bin/nvidia-smi (reported on irc by Berxwedan)

* Mon Jul 02 2012 tmb <tmb> 295.59-1.mga3.nonfree
+ Revision: 266542
- update to 295.59

* Wed Jun 06 2012 tmb <tmb> 295.49-6.mga3.nonfree
+ Revision: 256546
- rebuild for nonfree/release

* Mon Jun 04 2012 tv <tv> 295.49-5.mga3.nonfree
+ Revision: 253930
- bump release
- bump X11 ABI require

* Wed May 30 2012 tv <tv> 295.49-4.mga3.nonfree
+ Revision: 250053
- rebuild for new X.org server

* Sun May 27 2012 tmb <tmb> 295.49-3.mga3.nonfree
+ Revision: 247582
- fix build with 3.4 series kernels (P5)

* Thu May 10 2012 tmb <tmb> 295.49-2.mga2.nonfree
+ Revision: 235175
- submit to release

* Sun May 06 2012 tmb <tmb> 295.49-1.mga2.nonfree
+ Revision: 234830
- update to 295.49 (performance regression fixes)

* Wed Apr 11 2012 anssi <anssi> 295.40-1.mga2.nonfree
+ Revision: 230244
- new version 290.40
  o fixes CVE-2012-0946 (arbitrary system memory access by users)

* Fri Apr 06 2012 anssi <anssi> 295.33-1.mga2.nonfree
+ Revision: 229341
- new version 295.33
- drop now unneeded kernel 3.3 support patch

* Tue Mar 06 2012 tmb <tmb> 295.20-2.mga2.nonfree
+ Revision: 220369
- fix build with 3.3 series kernels (J.A. Magallon)

* Tue Mar 06 2012 anssi <anssi> 295.20-1.mga2.nonfree
+ Revision: 219541
- new version 295.20
- depend on the correct range of the newly provided xserver-abi(videodrv)
  in x11-server-common
- add support for new file types of 295.17 in %%install
- drop old unneeded mdv category from .desktop file (#2449)

* Wed Nov 30 2011 anssi <anssi> 290.10-1.mga2.nonfree
+ Revision: 174612
- new stable version 290.10
- run ldconfig explicitely in cuda-opencl package

* Sat Oct 08 2011 anssi <anssi> 285.05.09-1.mga2.nonfree
+ Revision: 152893
- new prerelease
  o adds X.org server 1.11 support

  + ahmad <ahmad>
    - Update to 280.13
    - Make it possible to download the sources from http://us.download.nvidia.com
      when ftp://download.nvidia.com doesn't have the latest driver.
    - Update to 280.11

* Sat Jul 02 2011 ahmad <ahmad> 280.04-1.mga2.nonfree
+ Revision: 117262
- Update to 280.04

* Tue Jun 14 2011 ahmad <ahmad> 275.09.07-1.mga2.nonfree
+ Revision: 106251
- Update to current official release 275.09.07
- Update to 275.09.04
- Rediff the kernel-rt patch

* Sat May 21 2011 ahmad <ahmad> 270.41.19-1.mga1
+ Revision: 100078
- update to 270.41.19

* Sat May 07 2011 anssi <anssi> 270.41.06-2.mga1
+ Revision: 95763
- remove dependency on X11 driver package from dkms-nvidia-current (it is
  not needed for CUDA/OpenCL usage) (Mandriva #63207)
- replace dependency on X11 driver package with a dependency on DKMS
  module package in nvidia-current-cuda-opencl (Mandriva #63207)

* Wed Apr 20 2011 ahmad <ahmad> 270.41.06-1.mga1
+ Revision: 89267
- Update to 270.41.06

* Sun Apr 17 2011 anssi <anssi> 270.41.03-2.mga1
+ Revision: 87344
- fix display-driver.conf alternative name
- replace "alias" entry with "install" entry in modprobe.conf to follow
  upstream module-init-tools behavior
- disable conflicts on videodrv ABI, as it may cause X server to be
  uninstalled instead
- remove now unneeded modprobe.preload.d entry

* Tue Apr 12 2011 ahmad <ahmad> 270.41.03-1.mga1
+ Revision: 83978
- update to 270.41.03, new official release

* Tue Mar 08 2011 ahmad <ahmad> 270.30-2.mga1
+ Revision: 66356
- restore the xserver driver ABI conflicts wrongly removed during removing
  old mdv scriptles/macros
- rename modprobe config file to display-driver.conf (Anssi)

* Wed Mar 02 2011 ahmad <ahmad> 270.30-1.mga1
+ Revision: 62721
- update to 270.30
- bump videodrv_abi to 10

* Thu Feb 24 2011 ahmad <ahmad> 270.26-2.mga1
+ Revision: 59002
- resubmit so that nvidia-current-cuda-opencl becomes available

* Tue Feb 22 2011 ahmad <ahmad> 270.26-1.mga1
+ Revision: 56909
- update to 270.26
- update the file list
- rename dyntwinview patch and modify it to say Mageia Control Center
- drop old/unneeded scriptlets
- rename .desktop file to mandriva-*
- imported package nvidia-current


* Thu Jan 27 2011 Anssi Hannula <anssi@mandriva.org> 260.19.36-1mdv2011.0
+ Revision: 633401
- new version
- clarify a comment in .spec

* Sun Dec 19 2010 Anssi Hannula <anssi@mandriva.org> 260.19.29-2mdv2011.0
+ Revision: 623119
- fix missing ldetect-lst list on 2010.2

* Sun Dec 19 2010 Ahmad Samir <ahmadsamir@mandriva.org> 260.19.29-1mdv2011.0
+ Revision: 622997
- update to 260.19.29

  + Anssi Hannula <anssi@mandriva.org>
    - hardcode videodrv abi as the driver is precompiled

* Thu Nov 11 2010 Thierry Vignaud <tv@mandriva.org> 260.19.21-2mdv2011.0
+ Revision: 595849
- require xorg server with proper ABI

* Wed Nov 10 2010 Ahmad Samir <ahmadsamir@mandriva.org> 260.19.21-1mdv2011.0
+ Revision: 595659
- Update to 260.19.21

  + Anssi Hannula <anssi@mandriva.org>
    - include headers again (NVIDIA restored a subset of the headers)

* Sat Oct 16 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 260.19.12-1mdv2011.0
+ Revision: 586001
- update to new version 260.19.12
- exclude GL header files

* Sat Oct 09 2010 Anssi Hannula <anssi@mandriva.org> 260.19.06-2mdv2011.0
+ Revision: 584444
- fix build with realtime-patched 2.6.33 series kernels (rt-2.6.33.patch)

* Wed Sep 15 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 260.19.06-1mdv2011.0
+ Revision: 578787
- update to new version 260.19.06

* Wed Sep 08 2010 Anssi Hannula <anssi@mandriva.org> 260.19.04-1mdv2011.0
+ Revision: 576845
- new beta version
- remove libnvidia-compiler.so workaround, fixed upstream
- handle pci id entries with subsystem ids in backport pcitable list
  generator

* Tue Aug 31 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 256.53-1mdv2011.0
+ Revision: 574801
- update to new version 256.53

* Sun Aug 29 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 256.52-1mdv2011.0
+ Revision: 574126
- update to new version 256.52

* Fri Jul 30 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 256.44-1mdv2011.0
+ Revision: 563735
- update to new version 256.44
- drop patch 4, fixed upstream

* Fri Jul 09 2010 Anssi Hannula <anssi@mandriva.org> 256.35-1mdv2011.0
+ Revision: 549893
- new version 256.35
- add ldetect-lst category assignment for backports to 2010.1
- drop nvidia-xconfig-ldflags-order.patch, fixed upstream
- remove now unneeded nvidia-xconfig,settings Makefile hacks
- install icons in fd.o Icon Theme Specification specified directories
  (legacy large icons dir is reportedly not always searched by KDE
   anymore, causing nvidia-settings icon to not appear when built with
   simple mode; reported by Rick Stockton)

* Wed Jun 16 2010 Anssi Hannula <anssi@mandriva.org> 195.36.31-1mdv2010.1
+ Revision: 548125
- new version 195.36.31
- fix nvidia-mdvbuild compatibility with NVIDIA 256.x beta driver series
  (Rick Stockton)
- fix build with older bash versions (2009.1 and older, reported by
  Len Lawrence)

* Wed May 05 2010 Anssi Hannula <anssi@mandriva.org> 195.36.24-3mdv2010.1
+ Revision: 542236
- package OpenCL nvidia.icd file
- use 0644 instead of 0444 as perms for some non-executable files
- add Provides on nvidia-current-cuda into nvidia-current-cuda-opencl

* Wed May 05 2010 Anssi Hannula <anssi@mandriva.org> 195.36.24-2mdv2010.1
+ Revision: 542223
- add a modprobe.preload.d entry loading the module before X server
- blacklist nouveau in modprobe.d entry as udev will now otherwise load it
- add support for building rpms of arbitrary installer versions
- replace file installation logic with a .manifest parser (required by
  the above, and this way is better for upcoming archive changes)

* Wed Apr 28 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 195.36.24-1mdv2010.1
+ Revision: 540569
- update to new version 195.36.24

* Fri Apr 02 2010 Anssi Hannula <anssi@mandriva.org> 195.36.15-4mdv2010.1
+ Revision: 530788
- add missing dot in description

  + Christophe Fergeau <cfergeau@mandriva.com>
    - split CUDA/OpenCL in its own subpackage

* Sun Mar 28 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 195.36.15-3mdv2010.1
+ Revision: 528506
- Patch4: fix it so it could cleanly apply on x86 too

  + Andrey Borzenkov <arvidjaar@mandriva.org>
    - patch4: fix parameter order in acpi_walk_namespace (http://bugs.gentoo.org/show_bug.cgi?id=301318#c9)

* Wed Mar 24 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 195.36.15-1mdv2010.1
+ Revision: 527250
- update to new version 195.36.15
- drop patch 4, not needed anymore
- fix file list (TODO: split CUDA and OpenCL files into a separate subpackages?)

* Fri Feb 26 2010 Andrey Borzenkov <arvidjaar@mandriva.org> 190.53-4mdv2010.1
+ Revision: 511446
- fix patch4: wrong order of parameters to acpi_walk_namespace
  ref: http://bugs.gentoo.org/show_bug.cgi?id=301318#c9

  + Anssi Hannula <anssi@mandriva.org>
    - fix missing instructions to enable dynamic twinview (update
      enable-dyntwinview-mdv.patch)

* Thu Jan 28 2010 Anssi Hannula <anssi@mandriva.org> 190.53-3mdv2010.1
+ Revision: 497692
- add one hunk into 2.6.33.patch for correctness (not strictly needed,
  though)
- update -devel summary and description
- do not strip anything except GPL stuff
- remove support for 2007.1 and older
- call ldconfig with -X option
- add local README.txt parsing to avoid having ship ldetect.lst in
  SOURCES

* Sun Dec 20 2009 Anssi Hannula <anssi@mandriva.org> 190.53-2mdv2010.1
+ Revision: 480304
- fix module build on 2.6.33+ (2.6.33.patch)

* Sat Dec 19 2009 Anssi Hannula <anssi@mandriva.org> 190.53-1mdv2010.1
+ Revision: 480066
- add includes on xf86vmproto.h on nvidia-settings
  (include-xf86vmproto.patch, fixes build on cooker)
- test pcitable file for correctly named entries during build
- disable DONT_STRIP (nvidia provided binaries are already stripped, and
  we do want to strip binaries built by us)
- 190.53
- adapt for moved vdpau drivers
- add a comment in .spec reminding to update ldetect-lst

* Fri Nov 06 2009 Anssi Hannula <anssi@mandriva.org> 190.42-2mdv2010.1
+ Revision: 461589
- rebuild due to a missing changelog entry for the previous release

* Fri Nov 06 2009 Anssi Hannula <anssi@mandriva.org> 190.42-1mdv2010.1
+ Revision: 461251
- fix build on 2006.0
- make rpm scripts return success on systems without ldetect-lst installed
- fix build on 2008.1 and older
- versionize suggests for doc-html to avoid urpmi trying to install
  doc-html for a different version from the repository
- provide a pcitable.d file in backported packages, so that XFdrake sees
  the installed nvidia driver as able to drive the graphics card even if
  ldetect-lst package does not know it
- new version 190.42
- drop 2.6.30-check-real-pat-with-cpuid.patch, fixed upstream
- drop xf86config-parser-add-disable-keyword.patch, fixed upstream
- rediff enable-dyntwinview-mdv.patch

* Sun Oct 18 2009 Anssi Hannula <anssi@mandriva.org> 185.18.36-4mdv2010.0
+ Revision: 458081
- fix parse error on Disable keyword in Load section of xorg.conf when
  trying to modify xorg.conf with nvidia-settings or nvidia-xconfig
  (add-disable-keyword.patch from upstream, fixes bug #53937)

* Fri Sep 25 2009 Anssi Hannula <anssi@mandriva.org> 185.18.36-3mdv2010.0
+ Revision: 449058
- add a comment to nvidia-settings xinit file
- fix loading of nvidia-settings settings on X startup (fixes #53936,
  reported by Barry Jackson, fix found by Gabi Teo)

* Fri Sep 18 2009 Anssi Hannula <anssi@mandriva.org> 185.18.36-2mdv2010.0
+ Revision: 444314
- require libvdpau in driver package; at least mplayer seems to dlopen
  libvdpau.so.1 instead of directly linking against it, so the package
  would otherwise not be pulled in by anything (suggested by Mieszko
  Kaczmarczyk)
- requires vdpau-devel in devel package on 2009.0+

* Sun Aug 23 2009 Anssi Hannula <anssi@mandriva.org> 185.18.36-1mdv2010.0
+ Revision: 419741
- new version

* Sat Aug 01 2009 Anssi Hannula <anssi@mandriva.org> 185.18.31-1mdv2010.0
+ Revision: 406071
- new version 185.18.31
- remove 2.6.31 patch, fixed upstream

* Thu Jul 30 2009 Anssi Hannula <anssi@mandriva.org> 185.18.14-5mdv2010.0
+ Revision: 404803
- use PAT on supported CPUs even if CPU is on kernel PAT blacklist (fixes
  performance regression on Pentium III, Core Solo, and Core Duo systems
  with kernel 2.6.30+, 2.6.30-check-real-pat-with-cpuid.patch, bug #52488)
- re-add update-menus for 2008.1 and earlier

* Wed Jul 22 2009 Anssi Hannula <anssi@mandriva.org> 185.18.14-4mdv2010.0
+ Revision: 398555
- restore 2009.1 XFdrake support (broken in previous release)
- fix title formatting of man pages (fixes #41638)
- rename man pages again from disabled-* to alt-*

* Sat Jul 18 2009 Anssi Hannula <anssi@mandriva.org> 185.18.14-3mdv2010.0
+ Revision: 397029
- load nvidia-settings configuration automatically when logging in (can
  be disabled with LOAD_NVIDIA_SETTINGS="no" in
  /etc/sysconfig/nvidia-settings
- build nvidia-settings and nvidia-xconfig from their source code
  tarballs (GPLv2)
- provide instructions for enabling dynamic twinview in nvidia-settings
  error message (enable-dyntwinview-mdv.patch, fixes #39921)
- fix format-string warnings in nvidia-settings (format-string.patch)
- make nvidia-xconfig build with ldflags (ldflags-order.patch)
- clean spec
- fix license tag
- update source rpm description
- drop removal of xen check, now unneeded
- drop general vdpau files from 2009+, they are provided in vdpau
  packages
- use more wildcards in %%install and less in %%files
- rename man pages of non-enabled drivers to disabled-* instead of making
  them hidden files
- remove libGL.la as no static library is provided
- use xorg_extra_modules on 2009.1+ for nvidia_drv.so as well

* Sat Jul 11 2009 Andrey Borzenkov <arvidjaar@mandriva.org> 185.18.14-2mdv2010.0
+ Revision: 394702
- patch100: enable kernel module build on 2.6.31

* Sun May 31 2009 Anssi Hannula <anssi@mandriva.org> 185.18.14-1mdv2010.0
+ Revision: 381671
- new version

* Wed Apr 22 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 180.51-1mdv2009.1
+ Revision: 368747
- Update to 180.51 (fix severe corruption of EDID on Fujitsu Celsion H270 notebook)
  (c.f. http://www.nvnews.net/vbulletin/showthread.php?t=131849)

* Mon Apr 13 2009 Anssi Hannula <anssi@mandriva.org> 180.44-2mdv2009.1
+ Revision: 366534
- adapt for dropped alternatives on /usr/bin/Xorg

* Wed Apr 01 2009 Anssi Hannula <anssi@mandriva.org> 180.44-1mdv2009.1
+ Revision: 363381
- new stable version (180.44)

* Mon Mar 30 2009 Pascal Terjan <pterjan@mandriva.org> 180.41-2mdv2009.1
+ Revision: 362270
- Bump release as 180.41 did not make it on i586

* Sat Mar 21 2009 Anssi Hannula <anssi@mandriva.org> 180.41-1mdv2009.1
+ Revision: 359878
- new version

* Fri Mar 20 2009 Anssi Hannula <anssi@mandriva.org> 180.37-1mdv2009.1
+ Revision: 359211
- new version

* Fri Mar 20 2009 Anssi Hannula <anssi@mandriva.org> 180.29-4mdv2009.1
+ Revision: 359163
- revert previous update, fixed in x11-server instead

* Thu Mar 19 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 180.29-3mdv2009.1
+ Revision: 357790
- ensure the alternatives links are created if its current state is manual

* Tue Mar 17 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 180.29-2mdv2009.1
+ Revision: 356867
- Adapt to recent alternatives changes (xorg extra modules dir)

  + Anssi Hannula <anssi@mandriva.org>
    - provide nvidia-smi man page

* Thu Feb 12 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 180.29-1mdv2009.1
+ Revision: 339658
- update to new version 180.29

* Thu Jan 29 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 180.27-1mdv2009.1
+ Revision: 335220
- update to new version 180.27

* Tue Jan 27 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 180.25-1mdv2009.1
+ Revision: 334243
- update to new version 180.25

* Fri Jan 09 2009 Adam Williamson <awilliamson@mandriva.org> 180.22-1mdv2009.1
+ Revision: 327370
- new release 180.22 (this hurried release brought to you by AdamW's Mighty
  Need to get his new graphics card working)

* Wed Dec 24 2008 Adam Williamson <awilliamson@mandriva.org> 180.18-1mdv2009.1
+ Revision: 318182
- new release 180.18

* Mon Dec 15 2008 Adam Williamson <awilliamson@mandriva.org> 180.16-1mdv2009.1
+ Revision: 314434
- new release 180.16

* Wed Dec 03 2008 Adam Williamson <awilliamson@mandriva.org> 180.11-1mdv2009.1
+ Revision: 309537
- new release 180.11

* Wed Dec 03 2008 Adam Williamson <awilliamson@mandriva.org> 180.08-5mdv2009.1
+ Revision: 309510
- drop the KDE 4 performance kludge, this is supposed to be handled now

* Tue Dec 02 2008 Anssi Hannula <anssi@mandriva.org> 180.08-4mdv2009.1
+ Revision: 309300
- include VDPAU support

* Sun Nov 30 2008 Adam Williamson <awilliamson@mandriva.org> 180.08-3mdv2009.1
+ Revision: 308274
- rebuild for new X server

* Wed Nov 26 2008 Adam Williamson <awilliamson@mandriva.org> 180.08-2mdv2009.1
+ Revision: 306824
- drop both tmb and 2.6.28 patches (fixes have been done upstream, tested)

* Sat Nov 22 2008 Adam Williamson <awilliamson@mandriva.org> 180.08-1mdv2009.1
+ Revision: 305670
- new release 180.08 (beta)

* Sat Nov 15 2008 Anssi Hannula <anssi@mandriva.org> 177.82-1mdv2009.1
+ Revision: 303529
- new version
- modify patches for new version

* Tue Nov 11 2008 Thomas Backlund <tmb@mandriva.org> 177.80-4mdv2009.1
+ Revision: 302012
- add support for building against 2.6.28 series kernels
- add support for building against kernel-tmb 2.6.27 series

* Tue Oct 14 2008 Pascal Terjan <pterjan@mandriva.org> 177.80-3mdv2009.1
+ Revision: 293756
- Remove some forgotten lines

* Tue Oct 14 2008 Pascal Terjan <pterjan@mandriva.org> 177.80-2mdv2009.1
+ Revision: 293726
- Drop our xen patch, a better one is now included upstream

* Sun Oct 12 2008 Anssi Hannula <anssi@mandriva.org> 177.80-1mdv2009.1
+ Revision: 292799
- new stable version 177.80

* Sat Oct 04 2008 Anne Nicolas <ennael@mandriva.org> 177.70-2mdv2009.0
+ Revision: 291122
- Fix #43716

* Wed Sep 03 2008 Stéphane Téletchéa <steletch@mandriva.org> 177.70-1mdv2009.0
+ Revision: 279745
- new beta version

* Sat Aug 23 2008 Anssi Hannula <anssi@mandriva.org> 177.68-1mdv2009.0
+ Revision: 275306
- new beta version

* Sun Aug 10 2008 Anssi Hannula <anssi@mandriva.org> 177.13-2mdv2009.0
+ Revision: 270245
- adapt for libdri.so handled by alternatives

* Sun Jul 20 2008 Anssi Hannula <anssi@mandriva.org> 177.13-1mdv2009.0
+ Revision: 239191
- new beta version
  o now supports only GF6 and newer chips
- update file list
- define %%cards for supported cards
- generalize %%driverpkgname

* Tue Jun 17 2008 Anssi Hannula <anssi@mandriva.org> 173.14.09-3mdv2009.0
+ Revision: 223065
- new version
- update installed files
- remove nvidia-settings workaround, fixed upstream
- remove 2.6.26 support patch, applied upstream
- call ldconfig explicitely, not handled by filetriggers in this case

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon Jun 09 2008 Anssi Hannula <anssi@mandriva.org> 173.14.05-2mdv2009.0
+ Revision: 217092
- workaround modeline parsing bug in nvidia-settings with LC_NUMERIC=C
  (known upstream, fixed in the next release, reported by Philippe Didier)
- add some comments

* Thu May 29 2008 Anssi Hannula <anssi@mandriva.org> 173.14.05-1mdv2009.0
+ Revision: 212850
- new version
- update 2.6.26 patch

* Sun May 11 2008 Anssi Hannula <anssi@mandriva.org> 173.08-2mdv2009.0
+ Revision: 205443
- add support for 2.6.26 (conditional upstream 2404825.diff)

* Mon Apr 14 2008 Anssi Hannula <anssi@mandriva.org> 173.08-1mdv2009.0
+ Revision: 192856
- new beta version
- restore menu for old releases

* Tue Apr 01 2008 Anssi Hannula <anssi@mandriva.org> 169.12-4mdv2008.1
+ Revision: 191502
- add versioned requires on kernel module on 2008.1

* Thu Mar 27 2008 Anssi Hannula <anssi@mandriva.org> 169.12-3mdv2008.1
+ Revision: 190679
- add upstream patch for 2.6.25 support, enabled conditionally

* Thu Mar 20 2008 Anssi Hannula <anssi@mandriva.org> 169.12-2mdv2008.1
+ Revision: 189241
- split html version of the documentation into nvidia-current-doc-html
- do not ship headers in documentation directory

* Fri Feb 29 2008 Anssi Hannula <anssi@mandriva.org> 169.12-1mdv2008.1
+ Revision: 176725
- new version

* Tue Jan 22 2008 Anssi Hannula <anssi@mandriva.org> 169.09-1mdv2008.1
+ Revision: 156466
- 169.09
  o fixes a problem causing the fan on some GPUs to always run at full
    speed
  o fixes a bug that caused the X driver to crash if the X.Org GLX
    extension module was loaded intead of NVIDIA's
  o improves the X driver's awareness of the current notebook docking
    status
  o fixes brightness control on HP Compaq notebooks
  o fixes a bug in the Linux/i2c algorithm driver implementation that
    prevented core transfer types from succeeding
- do not use Pascal's patch, it did not work

  + Pascal Terjan <pterjan@mandriva.org>
    - Don't disable AGP if Xen is compiled in but not in use

  + Thierry Vignaud <tv@mandriva.org>
    - drop old menu

* Tue Dec 25 2007 Anssi Hannula <anssi@mandriva.org> 169.07-1mdv2008.1
+ Revision: 137623
- 169.07
- drop 2.6.24 support patch, fixed upstream

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Dec 07 2007 Anssi Hannula <anssi@mandriva.org> 169.04-2mdv2008.1
+ Revision: 116285
- add patch for general 2.6.24 compatibility (S2, #35771)
- add patch for 2.6.24 xen compatibility, which actually mostly disables
  xen functionality, due to xen_features and hypercall_page, which are
  indirectly called by nvidia driver through macros in xen header files,
  now being GPL-only (S3)

* Wed Nov 21 2007 Anssi Hannula <anssi@mandriva.org> 169.04-1mdv2008.1
+ Revision: 111009
- 169.04 (beta)

* Fri Oct 19 2007 Anssi Hannula <anssi@mandriva.org> 100.14.19-3mdv2008.1
+ Revision: 100337
- on cooker, use libwfb.so from xorg server 1.4 instead of the NVIDIA
  provided one (according to documentation, this is also what NVIDIA's
  installer does)

* Mon Oct 15 2007 Anssi Hannula <anssi@mandriva.org> 100.14.19-2mdv2008.1
+ Revision: 98746
- handle upgrading from nvidia packages that do not have the libwfb files
  handled by alternatives (this change affects 2007.1 and earlier only,
  the problem does not exist when upgrading to 2008.0)
- use Makefile.kbuild explicitely for cleaning to prevent bad exit
  status during cleaning of the build area

* Mon Sep 24 2007 Anssi Hannula <anssi@mandriva.org> 100.14.19-1mdv2008.0
+ Revision: 92507
- add GTK category to the menu entry
- 100.14.19
  o adds support for Quadro FX 290,370,570,1700 GPUs
  o fixes GLX_EXT_texture_from_pixmap black window bug
  o fixes hang on logout with some hardware when 3d desktop is enabled
    (bug #33007)
  o lots of other bugfixes and improvements
- drop 2.6.23 support patch, fixed upstream

* Sat Sep 22 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-5mdv2008.0
+ Revision: 92226
- handle renaming of the driver from nvidia97xx as it can now be done
  easily due to the use of alternatives for libglx.so

* Fri Sep 07 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-4mdv2008.0
+ Revision: 81948
- fix 2.6.23 compatibility (NVIDIA_kernel-2.6.23.txt)

* Fri Aug 31 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-3mdv2008.0
+ Revision: 76854
- allow building against xen kernel (Guillaume Rousse)
- fix alternatives on backports

  + Thierry Vignaud <tv@mandriva.org>
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Sun Aug 26 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-2mdv2008.0
+ Revision: 71694
- use alternatives for libglx.so
- rename source rpm to nvidia-current to allow renaming binary packages
  when backporting to old releases
- shorten dkms driver name
- drop old requires on drakxtools
- use conflicts instead of requires on harddrake and drakx-kbd-mouse-x11
  (Thierry Vignaud)

* Thu Aug 09 2007 Anssi Hannula <anssi@mandriva.org> 100.14.11-1mdv2008.0
+ Revision: 60655
- do not call the next dkms step if previous fails
- rename from nvidia97xx to x11-driver-video-nvidia-current
- versionize obsoletes to avoid future problems
- add devel package (requested by Giuseppe)
- add support for 2006.0 (requested by Giuseppe)
- better descriptions and summaries
- add README.install.urpmi and README.manual-setup
- provide XvMCConfig via alternatives (bug #29109)
- add post and preun script requires on dkms
- require new update-alternatives instead of workarounding bugs
- include nvidia tools, handled by alternatives (bug #29107)
- add URL
- clean libGL.so.1 from provides (bug #28216)
- remove packager tag, prefix tag, requires on glibc
- fix file requires
- 100.14.11
- clean .spec
- fix 2007.0 compatibility
- drop unneeded ioctl32.patch
- use %%{version}-%%{release} for dkms PACKAGE_VERSION
- alternativeszificate unversioned libwfb.so properly
- do not add nvidia to modprobe.preload in 2007.0 either
- do not modprobe nvidia module in %%post, rmmod it instead
- Import nvidia97xx



* Mon Mar 26 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9755.1mdv
- 97.55
- provide libwfb.so symlink (#29751)
- don't add modules to /etc/mod{ules,probe.preload} (#29111)
- move libXvMCNVIDIA_dynamic.so.1 to %%{_libdir}/%%{name} (#29108)

* Thu Mar  1 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9746.3mdv
- remove XFdrake generated modprobe.conf

* Wed Feb 28 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9746.2mdv
- new layout for MDV 2007.1
- increase priority to match version level

* Tue Jan 16 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9746-1mdv
- 97.46

* Wed Nov  8 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-9629-1mdv
- 96.29

* Fri Nov  3 2006 Arnaud Patard <apatard@mandriva.com> 1.0-8776-1mdv
- 87.76

* Wed Sep 13 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8774-3mdv
- Use an alternative for the X.org module too

* Sat Sep  9 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8774-2mdk
- Use nvidia_drv.so for X.org 7.1
- Move nvidia.conf to ld.so.conf.d/GL/
- Move GL libraries to an nvidia/ subdir

* Fri Aug 25 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8774-1mdk
- 87.74

* Thu Aug 24 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8762-1mdk
- 87.62

* Mon Apr 10 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8756-1mdk
- 87.56

* Tue Dec 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8178-1mdk
- 81.78

* Tue Dec  6 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8174-1mdk
- 81.74

* Thu Sep 29 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-8163-1mdk
- 81.63

* Fri Sep 16 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-5mdk
- make ld.so.conf.d/%%{name}.conf config(noreplace)

* Mon Sep 12 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-4mdk
- fix scriptlets

* Thu Sep  1 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-3mdk
- description improvements
- ship with 32-bit tls libraries in the right subdir

* Fri Aug 26 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-2mdk
- move libglx.so to an nvidia/ subdir for X.org 6.9

* Wed Aug 17 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 7676-1mdk
- 76.76

* Wed Jul  6 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-7667-2mdk
- ship with nvidia-bug-report.sh

* Mon Jul  4 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-7667-1mdk
- 76.67

* Tue Jun  7 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 1.0-7664-1mdk
- 76.64

* Fri Apr  8 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-7174-1mdk
- 71.74

* Tue Mar 15 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-7167-2mdk
- 1.0-7167 for Linux x86/x86-64 updates (zander, nvnews.net)

* Fri Mar 11 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-7167-1mdk
- 71.67

* Fri Feb 18 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6633-1mdk
- 6633.

* Thu Jan 20 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6629-2mdk
- ship with tls library symlinks on 10.0/corpo

* Tue Dec  7 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6629-1mdk
- 6629.

* Tue Oct 26 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6111-2mdk
- move to dkms build

* Thu Aug 19 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6111-1mdk
- 6111.

* Wed Jul 28 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6106-2mdk
- fix build with kernel 2.4

* Fri Jul  2 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6106-1mdk
- 6106.

* Tue Jun  8 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6098-1mdk
- 6098.

* Fri May 28 2004 Nicolas Planel <nplanel@mandrakesoft.com> 1.0-6097-1mdk
- 6097.

* Wed May 26 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6096-3mdk
- move nvidia GL libs to a subdir

* Mon May 24 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0-6096-2mdk
- lib64 and 32-bit tls fixes

* Wed May 19 2004 Nicolas Planel <nplanel@mandrakesoft.com> 1.0-6096-1mdk
- First new release for x86_64.

